/*
 *  Scratch remote sensor protocol
 *
 *  You need to get ssid , password and host
 *  
 */

#include <ESP8266WiFi.h>

const char* ssid     = "PUT SSID HERE";
const char* password = "PUT PWD HERE";

const char* host = "PUT PC IP ADDRESS HERE";
const int Port = 42001;

void setup() {
  Serial.begin(115200);
  delay(10);

  // We start by connecting to a WiFi network

  Serial.println();
  Serial.println();
  Serial.print("Connecting to ");
  Serial.println(ssid);
  
  WiFi.begin(ssid, password);
  
  while (WiFi.status() != WL_CONNECTED) {
    delay(500);
    Serial.print(".");
  }

  Serial.println("");
  Serial.println("WiFi connected");  
  Serial.println("IP address: ");
  Serial.println(WiFi.localIP());
}

int value = 0;

void loop() {

  uint8_t buffer[128] = {0};
  
  delay(5000);
  ++value;

  Serial.print("connecting to ");
  Serial.println(host);
  
  // Use WiFiClient class to create TCP connections
  WiFiClient client;

  if (!client.connect(host, Port)) {
    Serial.println("connection failed");
    return;
  }
  
  Serial.print("create tcp ok\r\n");

  char *broadcastcmd = "sensor-update \"v\" 0 ";
  for(uint32_t n = 0; n <100000; n++) {
    delay(10);
    char scmd[32] = {0};
    int sw,stat;

// Read all from server and print them to Serial    
   client.setTimeout(100);  
   uint32_t len = client.readBytes(buffer, sizeof(buffer));
    if (len > 0) {
        Serial.print("Received:[");
        for(uint32_t i = 0; i < len; i++) {
            Serial.print((char)buffer[i]);
        }
        Serial.print("]\r\n");
    }

// send broadcast message   
    if(digitalRead(4)!=sw) {
      sw=digitalRead(4);stat=1;
      strcpy(scmd+4,"broadcast \"m\"");
    } else {
      if(stat==1) {
        stat=0;
        if(digitalRead(4)==LOW) {
          strcpy(scmd+4,"sensor-update \"v\" 0 ");
         } else {
           strcpy(scmd+4,"sensor-update \"v\" 1 ");
         }
      } 
    }
    scmd[3]=(uint8_t)strlen(scmd+4);
    if(0!=strlen(scmd+4)) {
      for(uint32_t i = 0; i < 4 + strlen(broadcastcmd); i++) {
        Serial.print(scmd[i]);} //Serial.print(" ");
        if (client.write((const uint8_t*)scmd, 4 + strlen(scmd+4))) {
          Serial.println("send ok");
        } else {
          Serial.println("send err");
        }
      }   
   }   
}

